import { getMeetingRoom, getLabelTree, myMeetingPage, getReserveRoomList, getAllScheduleWithMeetingRoomByTime } from '../../api/request'
import { EEXIST } from 'constants'
import { resolve } from 'url'
import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    equipFacilityList: [],
    reserveRoomList: [],
    lableTreeList: [],
    timeListStr:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24],
    search: {
      category: '',
      locationName: '全部区域',
      locationId: '',
      equipFacilityIds: [],
      time: ''
    },
    dataNum: '0',
    location:{
      id: '',
      name: ''
    },
    isShowModal: false,
    isShowLableModal: false,
    modalList: [],
    meetingTime: {
      startTime: '',
      endTime: '',
      date: '',
      meetingRoomId: '',
      meetingRoomName: ''
    },
    canScroll: true,
    modalOccupyTimeSlotTime: '123'
  },
  onLoad(query) {
    let date = new Date(this.store.data.startTime.replace(/-/g, "/"))
    // let date = new Date()
    let year = date.getFullYear()
    let month = `${date.getMonth() + 1}`
    let day = `${date.getDate()}`
    let search = {
      time: `${year}-${month.length > 1 ? month : '0'+month}-${day.length > 1 ? day : '0'+day}`,
      category: '全部分类',
      location: '全部区域'
    }
    this.setData({
      'search.time': `${year}-${month.length > 1 ? month : '0'+month}-${day.length > 1 ? day : '0'+day}`
    })
    this.getPageData()
  },
  onShow() {
  },
  getPageData() {
    let that = this
    let data = {
      scene: 'meeting_room_facility'
    }
    // 获取会议室设施的List
    getLabelTree(data).then(res => {
      let list = res.data.data.map(item => {
        return {
          name: item.name,
          isChecked: false,
          id: item.id
        }
      })
      that.setData({
        equipFacilityList: list
      })
      let data2 = {
        startTime: that.data.search.time,
        locationId: '',
        categoryId: '',
        equipFacilityIds: '',
      }
      getReserveRoomList(data2).then(res => {
        if (res.data.data) {
          let reserveRoomList = res.data.data.map(item => {
            let startTime = parseInt(item.timeSlotWithMeetingVOS[0].reserveStartTime.substring(0, 2))
            let endTime = parseInt(item.timeSlotWithMeetingVOS[item.timeSlotWithMeetingVOS.length - 1].reserveEndTime.substring(0, 2))
            let timeList = []
            for (let i = startTime; i < endTime; i++) {
              timeList.push(i)
            }
            return {
              ...item,
              timeList,
            }
          })
          that.setData({
            reserveRoomList: reserveRoomList
          })
        }
      })
    })
  },
  selectSearchTime() {
    let that = this
    dd.datePicker({
      format: 'yyyy-MM-dd',
      currentDate: this.data.search.time,
      success: (res) => {
        if (res !== {}) {
          that.setData({
            'search.time': res.date
          }, () => {
            that.getRoomList()
          })
        }
      },
      complete: (res) => {
        // res
      }
    });
  },
  // 弹出modal选择会议时间
  changeRoomTime(e) {
    let that = this
    let roomId = e.currentTarget.dataset.roomid;
    let dateTime = this.data.search.time
    let modalDate = new Date();
    let modalMins = modalDate.getMinutes();
    let modalHour = modalMins<30 ? modalDate.getHours()<10? '0'+modalDate.getHours():modalDate.getHours() : (modalDate.getHours() + 1)<10? '0'+ (modalDate.getHours() + 1):(modalDate.getHours() + 1)
    let data = {
      meetingRoomId: roomId,
      startTime: dateTime
    }
    this.setData({
      'meetingTime.date': dateTime,
      'meetingTime.meetingRoomId': e.currentTarget.dataset.roomid,
      'meetingTime.meetingRoomName': e.currentTarget.dataset.roomname
    })
    getReserveRoomList(data).then(res => {
      let modalList = res.data.data[0].timeSlotWithMeetingVOS.map(item => {
        // 判断是否过期
        if (item.reserveStatus === 'expired' || item.reserveStatus === 'occupied') {
          return {
            ...item,
            status: 'BeOverdue',
            reserveStartTime: `${dateTime} ${item.reserveStartTime}`,
            reserveEndTime: `${dateTime} ${item.reserveEndTime}`
          }
        } else {
          return {
            ...item,
            status: 'Uncheck',
            reserveStartTime: `${dateTime} ${item.reserveStartTime}`,
            reserveEndTime: `${dateTime} ${item.reserveEndTime}`
          }
        }
      })
      that.setData({
        modalList: modalList,
        isShowModal: true,
        // modalOccupyTimeSlotTime: `${modalHour}:${modalMins<30? '30' : '00'}`
        modalOccupyTimeSlotTime: '10:30'
      })
    })
  },
  modalScroll(){
    this.setData({
      modalOccupyTimeSlotTime: '12312312'
    })
  },
  // 修改弹框checkBox
  onChangeModalTime(e){
    let that = this;
    let index = e.currentTarget.dataset.index;
    let data = this.data.modalList[index]; // 点击的数据
    if (data.status === 'BeOverdue') {
      return false;
    }
    if (!this.data.meetingTime.startTime && !this.data.meetingTime.endTime) { 
      // 判断是否有开始时间
      console.log('判断是否有开始时间')
      let listStr = `modalList[${index}].status`
      this.setData({
        'meetingTime.startTime': data.reserveStartTime,
        [listStr]: 'checked'
      })
    } else if (this.data.meetingTime.startTime && !this.data.meetingTime.endTime) { 
      // 判断有开时间，没有结束时间
      if (this.data.meetingTime.startTime === data.reserveStartTime) {
        // 点击的同一个checkBox
        let listStr = `modalList[${index}].status`
        this.setData({
          'meetingTime.startTime': '',
          [listStr]: 'Uncheck'
        })
        console.log('2.1')
      } else if (new Date(this.data.meetingTime.startTime.replace(/-/g, '/')).getTime() > new Date(data.reserveStartTime.replace(/-/g, '/')).getTime()){
        //比已选时间小
        console.log('2.2')
        if (this.isDaySpan(this.data.meetingTime.startTime.replace(/-/g, '/'),data.reserveStartTime.replace(/-/g, '/'))) {
          //非跨天
          if (this.isOptional(data.reserveStartTime, this.data.meetingTime.startTime)) {
            this.setData({
              'meetingTime.startTime': data.reserveStartTime,
              'meetingTime.endTime': this.data.meetingTime.startTime,
            }, () => {
              that.refreshModalList()
            })
          } else {
            console.log('已有会议，不可点击')
          }
        } else {
          //跨天
          this.getAllScheduleWithMeetingRoomByTime(data.reserveStartTime, this.data.meetingTime.startTime).then(res => {
            if (res) {
              that.setData({
                'meetingTime.startTime': data.reserveStartTime,
                'meetingTime.endTime': this.data.meetingTime.startTime,
              }, () => {
                that.refreshModalList()
              })
            } else {
              dd.alert({
                content: '会议室已被占用',
              });
            }
          })
        }
      } else {
        //比已选时间大
        console.log('2.3')
        if (this.isDaySpan(this.data.meetingTime.startTime.replace(/-/g, '/'),data.reserveStartTime.replace(/-/g, '/'))) {
          // 非跨天
          if (this.isOptional(this.data.meetingTime.startTime, data.reserveStartTime)) {
            this.setData({
              'meetingTime.endTime': data.reserveStartTime,
            }, () => {
              that.refreshModalList()
            })
          } else {
            console.log('已有会议')
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(data.reserveStartTime, this.data.meetingTime.startTime).then(res => {
            if (res) {
              that.setData({
                'meetingTime.endTime': data.reserveStartTime,
              }, () => {
                that.refreshModalList()
              })
            } else {
              dd.alert({
                content: '会议室已被占用',
              });
            }
          })
        }
      }
    } else if (this.data.meetingTime.startTime && this.data.meetingTime.endTime) {
      //判断有开始时间和结束时间
      if (this.data.meetingTime.startTime === data.reserveStartTime) {
        //开始时间等于点击的开始时间，取消第一个的操作
        console.log('3.1')
        let startTimeDate = new Date(this.data.meetingTime.startTime.replace(/-/g, '/'))
        startTimeDate.setMinutes(startTimeDate.getMinutes() + 30)
        let meetingStartTime = `${startTimeDate.getFullYear()}-${startTimeDate.getMonth()+1<10 ? '0' + (startTimeDate.getMonth()+1) : startTimeDate.getMonth()+1}-${startTimeDate.getDate()<10? '0' + startTimeDate.getDate(): startTimeDate.getDate()} ${startTimeDate.getHours()<10?'0'+startTimeDate.getHours():startTimeDate.getHours()}:${startTimeDate.getMinutes()<10?'0'+startTimeDate.getMinutes():startTimeDate.getMinutes()}`
        if (meetingStartTime === this.data.meetingTime.endTime) {
          this.setData({
            'meetingTime.startTime': meetingStartTime,
            'meetingTime.endTime': ''
          },() => {
            that.refreshModalList()
          })
        } else {
          this.setData({
            'meetingTime.startTime': meetingStartTime
          },() => {
            that.refreshModalList()
          })
        }
      } else if(this.data.meetingTime.endTime === data.reserveStartTime){
        //开始时间等于点击的结束时间，取消最后一个的操作
        console.log('3.2')
        let endTimeDate = new Date(this.data.meetingTime.endTime.replace(/-/g, '/'))
        endTimeDate.setMinutes(endTimeDate.getMinutes() - 30)
        let meetingEndTime = `${endTimeDate.getFullYear()}-${endTimeDate.getMonth()+1<10 ? '0' + (endTimeDate.getMonth()+1) : endTimeDate.getMonth()+1}-${endTimeDate.getDate()<10?'0'+endTimeDate.getDate():endTimeDate.getDate()} ${endTimeDate.getHours()<10?'0'+endTimeDate.getHours():endTimeDate.getHours()}:${endTimeDate.getMinutes()<10?'0'+endTimeDate.getMinutes():endTimeDate.getMinutes()}`
        if (meetingEndTime === this.data.meetingTime.startTime) {
          this.setData({
            'meetingTime.endTime': ''
          },() => {
            that.refreshModalList()
          })
        } else {
          this.setData({
            'meetingTime.endTime': meetingEndTime
          },() => {
            that.refreshModalList()
          })
        }
      } else if(new Date(this.data.meetingTime.startTime.replace(/-/g, '/')).getTime() > new Date(data.reserveStartTime.replace(/-/g, '/')).getTime()){
        //比已选时间小
        console.log('3.3')
        // 判断是否跨天
        if (this.isDaySpan(this.data.meetingTime.startTime.replace(/-/g, '/'),data.reserveStartTime.replace(/-/g, '/'))) {
          // 非跨天
          if (data.reserveStartTime, this.data.meetingTime.startTime) {
            this.setData({
              'meetingTime.startTime': data.reserveStartTime,
            },() => {
              that.refreshModalList()
            })
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(data.reserveStartTime, this.data.meetingTime.startTime).then(res => {
            if (res) {
              that.setData({
                'meetingTime.startTime': data.reserveStartTime,
              },() => {
                that.refreshModalList()
              })
            } else {
              dd.alert({
                content: '会议室已被占用',
              });
            }
          })
        }
      } else {
        //比已选时间大直接赋值endTime
        console.log('3.4')
        if (this.isDaySpan(this.data.meetingTime.startTime.replace(/-/g, '/'),data.reserveStartTime.replace(/-/g, '/'))) {
          // 非跨天
          if (this.isOptional(this.data.meetingTime.startTime, data.reserveStartTime)) {
            //是否可选中
            this.setData({
              'meetingTime.endTime': data.reserveStartTime,
            },() => {
              that.refreshModalList()
            })
          }
        } else {
          // 跨天
          this.getAllScheduleWithMeetingRoomByTime(data.reserveStartTime, this.data.meetingTime.startTime).then(res => {
            if (res) {
              that.setData({
              'meetingTime.endTime': data.reserveStartTime,
              },() => {
                that.refreshModalList()
              })
            } else {
              dd.alert({
                content: '会议室已被占用',
              });
            }
          })
        }
      }
    }
  },
  // 接口判断跨天会议是否可点击
  getAllScheduleWithMeetingRoomByTime(startTime,endTime){
    let endTimeDate = new Date(endTime.replace(/-/g, '/'))
    endTimeDate.setMinutes(endTimeDate.getMinutes() + 30)
    let data = {
      meetingRoomId: this.data.meetingTime.meetingRoomId,
      startTime: `${startTime}:00`,
      endTime: `${endTimeDate.getFullYear()}-${endTimeDate.getMonth()+1<10 ? '0'+ (endTimeDate.getMonth()+1) : endTimeDate.getMonth()+1}-${endTimeDate.getDate()<10?'0'+endTimeDate.getDate():endTimeDate.getDate()} ${endTimeDate.getHours()<10? '0'+endTimeDate.getHours():endTimeDate.getHours()}:${endTimeDate.getMinutes()<10? '0'+endTimeDate.getMinutes():endTimeDate.getMinutes()}:00`
    }
    return getAllScheduleWithMeetingRoomByTime(data).then(res => {
      return res.data.data
    })
  },
  // 非跨天会议是否可点击
  isOptional(startTime, endTime) {
    let startTimeMS = new Date(startTime.replace(/-/g, '/')).getTime();
    let endTimeMs = new Date(endTime.replace(/-/g, '/')).getTime();
    let UnDisable = true
    this.data.modalList.map(item => {
      let itemReserveStartTime = new Date(item.reserveStartTime.replace(/-/g, '/')).getTime();
      if ( itemReserveStartTime >= startTimeMS && itemReserveStartTime <= endTimeMs) {
        if (item.reserveStatus === 'expired' || item.reserveStatus === 'occupied') {
          UnDisable = false
        }
      }
    })
    return UnDisable;
  },
  // 更新渲染数据
  refreshModalList(){
    let startTimeMS = new Date(this.data.meetingTime.startTime.replace(/-/g, '/')).getTime();
    let endTimeMs = new Date(this.data.meetingTime.endTime.replace(/-/g, '/')).getTime();
    let modalList = this.data.modalList.map(item => {
      let itemReserveStartTime = new Date(item.reserveStartTime.replace(/-/g, '/')).getTime();
      if (itemReserveStartTime === startTimeMS || (itemReserveStartTime >= startTimeMS && itemReserveStartTime <= endTimeMs)) {
        return {
          ...item,
          status: 'checked'
        }
      } else {
        if (item.reserveStatus=== 'expired' || item.reserveStatus=== 'occupied') {
          return {
            ...item,
            status: 'BeOverdue'
          }
        } else {
          return {
            ...item,
            status: 'Uncheck'
          }
        }
      }
    })
    this.setData({
      modalList: modalList
    })
  },
  isDaySpan(date1, date2) {
    var date1 = new Date(date1.substr(0,10));
    var date2 = new Date(date2.substr(0,10));
    var date = (date2.getTime() - date1.getTime()) / (1000 * 60 * 60 * 24);/*不用考虑闰年否*/
    return date === 0
  },
  // 点击今天明天后天
  chooseDate(e){
    let that = this;
    let modalDate = new Date();
    let modalMins = modalDate.getMinutes();
    let modalHour = modalMins<30 ? modalDate.getHours()<10? '0'+modalDate.getHours():modalDate.getHours() : (modalDate.getHours() + 1)<10? '0'+ (modalDate.getHours() + 1):(modalDate.getHours() + 1)
    let num = parseInt(e.currentTarget.dataset.num);
    let selectDate = new Date(this.data.meetingTime.date);
    selectDate.setDate(selectDate.getDate() + num)
    let meetingDate = `${selectDate.getFullYear()}-${selectDate.getMonth()+1<10 ? '0' + (selectDate.getMonth()+1) : selectDate.getMonth()+1}-${selectDate.getDate()<10? '0' + selectDate.getDate(): selectDate.getDate()}`
    let data = {
      meetingRoomId: that.data.meetingTime.meetingRoomId,
      startTime: meetingDate
    }
    getReserveRoomList(data).then(res => {
      let modalList = res.data.data[0].timeSlotWithMeetingVOS.map(item => {
        // 判断是否过期
        if (item.reserveStatus === 'expired' || item.reserveStatus === 'occupied') {
          return {
            ...item,
            status: 'BeOverdue',
            reserveStartTime: `${meetingDate} ${item.reserveStartTime}`,
            reserveEndTime: `${meetingDate} ${item.reserveEndTime}`
          }
        } else {
          return {
            ...item,
            status: 'Uncheck',
            reserveStartTime: `${meetingDate} ${item.reserveStartTime}`,
            reserveEndTime: `${meetingDate} ${item.reserveEndTime}`
          }
        }
      })
      if (this.data.meetingTime.startTime) {
        let startTimeMS = new Date(this.data.meetingTime.startTime.replace(/-/g, '/')).getTime();
        let endTimeMs = new Date(this.data.meetingTime.endTime.replace(/-/g, '/')).getTime();
        let modalList2 = modalList.map(item => {
          let itemReserveStartTime = new Date(item.reserveStartTime.replace(/-/g, '/')).getTime();
          if (itemReserveStartTime === startTimeMS || (itemReserveStartTime >= startTimeMS && itemReserveStartTime <= endTimeMs)) {
            return {
              ...item,
              status: 'checked'
            }
          } else {
            if (item.reserveStatus === 'expired' || item.reserveStatus === 'occupied') {
              return {
                ...item,
                status: 'BeOverdue'
              }
            } else {
              return {
                ...item,
                status: 'Uncheck'
              }
            }
          }
        })
        that.setData({
          modalList: modalList2,
          dataNum: num,
          modalOccupyTimeSlotTime: `${modalHour}:${modalMins<30? '30' : '00'}`
        })
      } else {
        that.setData({
          modalList: modalList,
          dataNum: num,
          modalOccupyTimeSlotTime: `${modalHour}:${modalMins<30? '30' : '00'}`
        })
      }
    })
  },
  onCancel(){
    this.setData({
      isShowModal: false,
      modalList: [],
      meetingTime: {
        startTime: '',
        endTime: '',
        date: '',
        meetingRoomId: ''
      },
      dataNum: 0
    })
  },
  onDetermine(){
    let startTime = this.data.meetingTime.startTime
    if (this.data.meetingTime.endTime) {
      var endTimeDate = new Date(this.data.meetingTime.endTime.replace(/-/g, '/'))
      endTimeDate.setMinutes(endTimeDate.getMinutes() + 30)
      this.store.data.startTime = `${startTime}:00`
      this.store.data.endTime = `${endTimeDate.getFullYear()}-${endTimeDate.getMonth()+1<10 ? '0'+ (endTimeDate.getMonth()+1) : endTimeDate.getMonth()+1}-${endTimeDate.getDate()<10?'0'+endTimeDate.getDate():endTimeDate.getDate()} ${endTimeDate.getHours()<10? '0'+endTimeDate.getHours():endTimeDate.getHours()}:${endTimeDate.getMinutes()<10? '0'+endTimeDate.getMinutes():endTimeDate.getMinutes()}:00`
      this.store.data.locationName = this.data.meetingTime.meetingRoomName
      this.store.data.roomId = this.data.meetingTime.meetingRoomId
      this.update()
      dd.navigateBack({
        delta: 2
      })
    } else {
      var endTimeDate = new Date(this.data.meetingTime.startTime.replace(/-/g, '/'))
      endTimeDate.setMinutes(endTimeDate.getMinutes() + 30)
      this.store.data.startTime = `${startTime.replace(/-/g, '/')}:00`
      this.store.data.endTime = `${endTimeDate.getFullYear()}/${endTimeDate.getMonth()+1<10 ? '0'+ (endTimeDate.getMonth()+1) : endTimeDate.getMonth()+1}/${endTimeDate.getDate()<10?'0'+endTimeDate.getDate():endTimeDate.getDate()} ${endTimeDate.getHours()<10? '0'+endTimeDate.getHours():endTimeDate.getHours()}:${endTimeDate.getMinutes()<10? '0'+endTimeDate.getMinutes():endTimeDate.getMinutes()}:00`
      this.store.data.locationName = this.data.meetingTime.meetingRoomName
      this.store.data.roomId = this.data.meetingTime.meetingRoomId
      this.update()
      dd.navigateBack({
        delta: 2
      })
    }
  },
  getRoomList() {
    let that = this
    let data = {
      startTime: that.data.search.time,
      locationId: that.data.search.locationId,
      equipFacilityIds: that.data.search.equipFacilityIds.toString()
    }
    getReserveRoomList(data).then(res => {
      if (res.data.data) {
        let reserveRoomList = res.data.data.map(item => {
          let startTime = parseInt(item.timeSlotWithMeetingVOS[0].reserveStartTime.substring(0, 2))
          let endTime = parseInt(item.timeSlotWithMeetingVOS[item.timeSlotWithMeetingVOS.length - 1].reserveEndTime.substring(0, 2))
          let timeList = []
          for (let i = startTime; i < endTime; i++) {
            timeList.push(i)
          }
          return {
            ...item,
            timeList,
          }
        })
        that.setData({
          reserveRoomList: reserveRoomList
        })
      } else {
        that.setData({
          reserveRoomList: []
        })
      }
    })
  },
  changeLocation(){
    let that = this
    let data = {
      scene: 'meeting_room_location'
    }
    // 获取会议室设施的List
    getLabelTree(data).then(res => {
      that.setData({
        lableTreeList: res.data.data,
        isShowLableModal: true,
        'location.id': that.data.search.locationId,
        'location.name': that.data.search.locationName,
      })
    })
  },
  onPropsCS(e){
    let that = this
    if (e.type == 'sure') {
      this.setData({
        isShowLableModal: false,
        'search.locationId': e.id,
        'search.locationName': e.name
      },() => {
        that.getRoomList()
      })
    } else {
      this.setData({
        isShowLableModal: false
      })
    }
  },
  changeSearchEquipFacility(e){
    let that = this
    let id = e.currentTarget.dataset.id;
    let index = this.data.search.equipFacilityIds.indexOf(id)
    if ( index === -1) {
      let data = [...this.data.search.equipFacilityIds]
      data.push(id)
      this.setData({
        'search.equipFacilityIds': data
      }, () => {
        that.getRoomList()
      })
    } else {
      let data = [...this.data.search.equipFacilityIds]
      data.splice(index, 1)
      this.setData({
        'search.equipFacilityIds': data
      }, () => {
        that.getRoomList()
      })
    }
  },
  onReady() {
    // 页面加载完成
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },
  onShareAppMessage() {
   // 返回自定义分享信息
  }
})